/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.http;

import java.util.List;
import com.squareup.okhttp.Interceptor;

/**
 * The interface for AutoRestHttpInfrastructureTestService class.
 */
public interface AutoRestHttpInfrastructureTestService {
    /**
     * Gets the URI used as the base for all cloud service requests.
     * @return the BaseUri value.
     */
    String getBaseUri();

    /**
     * Gets the list of interceptors the OkHttp client will execute.
     * @return the list of interceptors.
     */
    List<Interceptor> getClientInterceptors();

    /**
     * Gets the HttpFailure object to access its operations.
     * @return the httpFailure value.
     */
    HttpFailure getHttpFailure();

    /**
     * Gets the HttpSuccess object to access its operations.
     * @return the httpSuccess value.
     */
    HttpSuccess getHttpSuccess();

    /**
     * Gets the HttpRedirects object to access its operations.
     * @return the httpRedirects value.
     */
    HttpRedirects getHttpRedirects();

    /**
     * Gets the HttpClientFailure object to access its operations.
     * @return the httpClientFailure value.
     */
    HttpClientFailure getHttpClientFailure();

    /**
     * Gets the HttpServerFailure object to access its operations.
     * @return the httpServerFailure value.
     */
    HttpServerFailure getHttpServerFailure();

    /**
     * Gets the HttpRetry object to access its operations.
     * @return the httpRetry value.
     */
    HttpRetry getHttpRetry();

    /**
     * Gets the MultipleResponses object to access its operations.
     * @return the multipleResponses value.
     */
    MultipleResponses getMultipleResponses();

}
