/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
*/

import { ServiceClientOptions, RequestOptions, ServiceCallback } from 'ms-rest';
import * as models from '../models';


/**
 * @class
 * ParameterGrouping
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestParameterGroupingTestService.
 */
export interface ParameterGrouping {

    /**
     * Post a bunch of required parameters grouped
     *
     * @param {object} parameterGroupingPostRequiredParameters Additional
     * parameters for the operation
     * 
     * @param {number} [parameterGroupingPostRequiredParameters.body]
     * 
     * @param {string} [parameterGroupingPostRequiredParameters.customHeader]
     * 
     * @param {number} [parameterGroupingPostRequiredParameters.query] Query
     * parameter with default
     * 
     * @param {string} [parameterGroupingPostRequiredParameters.path] Path
     * parameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequired(parameterGroupingPostRequiredParameters: models.ParameterGroupingPostRequiredParameters, options: RequestOptions, callback: ServiceCallback<void>): void;
    postRequired(parameterGroupingPostRequiredParameters: models.ParameterGroupingPostRequiredParameters, callback: ServiceCallback<void>): void;

    /**
     * Post a bunch of optional parameters grouped
     *
     * @param {object} [parameterGroupingPostOptionalParameters] Additional
     * parameters for the operation
     * 
     * @param {string} [parameterGroupingPostOptionalParameters.customHeader]
     * 
     * @param {number} [parameterGroupingPostOptionalParameters.query] Query
     * parameter with default
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptional(parameterGroupingPostOptionalParameters: models.ParameterGroupingPostOptionalParameters, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptional(parameterGroupingPostOptionalParameters: models.ParameterGroupingPostOptionalParameters, callback: ServiceCallback<void>): void;

    /**
     * Post parameters from multiple different parameter groups
     *
     * @param {object} [firstParameterGroup] Additional parameters for the
     * operation
     * 
     * @param {string} [firstParameterGroup.headerOne]
     * 
     * @param {number} [firstParameterGroup.queryOne] Query parameter with default
     * 
     * @param {object}
     * [parameterGroupingPostMultipleParameterGroupsSecondParameterGroup]
     * Additional parameters for the operation
     * 
     * @param {string}
     * [parameterGroupingPostMultipleParameterGroupsSecondParameterGroup.headerTwo]
     * 
     * @param {number}
     * [parameterGroupingPostMultipleParameterGroupsSecondParameterGroup.queryTwo]
     * Query parameter with default
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postMultipleParameterGroups(firstParameterGroup: models.FirstParameterGroup, parameterGroupingPostMultipleParameterGroupsSecondParameterGroup: models.ParameterGroupingPostMultipleParameterGroupsSecondParameterGroup, options: RequestOptions, callback: ServiceCallback<void>): void;
    postMultipleParameterGroups(firstParameterGroup: models.FirstParameterGroup, parameterGroupingPostMultipleParameterGroupsSecondParameterGroup: models.ParameterGroupingPostMultipleParameterGroupsSecondParameterGroup, callback: ServiceCallback<void>): void;

    /**
     * Post parameters with a shared parameter group object
     *
     * @param {object} [firstParameterGroup] Additional parameters for the
     * operation
     * 
     * @param {string} [firstParameterGroup.headerOne]
     * 
     * @param {number} [firstParameterGroup.queryOne] Query parameter with default
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postSharedParameterGroupObject(firstParameterGroup: models.FirstParameterGroup, options: RequestOptions, callback: ServiceCallback<void>): void;
    postSharedParameterGroupObject(firstParameterGroup: models.FirstParameterGroup, callback: ServiceCallback<void>): void;
}
