/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the Foo class.
 * @constructor
 * The URIs that are used to perform a retrieval of a public blob, queue or
 * table object.
 * @member {object} [barPoint] Bar point
 * 
 * @member {object} [barPoint.recursivePoint] Recursive Endpoints
 * 
 * @member {string} [barPoint.recursivePoint.blob] Gets the blob endpoint.
 * 
 * @member {string} [barPoint.recursivePoint.queue] Gets the queue endpoint.
 * 
 * @member {string} [barPoint.recursivePoint.table] Gets the table endpoint.
 * 
 * @member {object} [barPoint.recursivePoint.dummyEndPoint] Dummy EndPoint
 * 
 * @member {object} [barPoint.recursivePoint.fooPoint] Foo point
 * 
 */
function Foo(parameters) {
  if (parameters !== null && parameters !== undefined) {
    if (parameters.barPoint) {
      this.barPoint = new models['Bar'](parameters.barPoint);
    }
  }    
}


/**
 * Validate the payload against the Foo schema
 *
 * @param {JSON} payload
 *
 */
Foo.prototype.serialize = function () {
  var payload = {};
  if (this['barPoint']) {
    payload['BarPoint'] = this['barPoint'].serialize();
  }

  return payload;
};

/**
 * Deserialize the instance to Foo schema
 *
 * @param {JSON} instance
 *
 */
Foo.prototype.deserialize = function (instance) {
  if (instance) {
    if (instance['BarPoint']) {
      this['barPoint'] = new models['Bar']().deserialize(instance['BarPoint']);
    }
  }

  return this;
};

module.exports = Foo;
